#' Deprecated function(s) in the ipeglim package
#' 
#' These functions are provided for compatibility with older version of
#' the package \code{ipeglim}.
#' They may eventually be completely removed.
#'
#' @rdname ipeglim_deprecated
#' @name ipeglim_deprecated
#' @param ... Parameters to be passed to the most recent version of the function
#' @docType package
#' 
#' @aliases cvxh
#' @export cvxh
#'
#' @section Details:
#' \tabular{rl}{
#'   \code{cvxh} \tab use the function \code{chull} in the base package\cr
#'   \code{addOnBoundaries} \tab now a synonym for \code{set.grid}\cr
#'   \code{addOnBoundaries.default} \tab now a synonym for \code{set.grid}\cr
#' }
#'  
cvxh <- function(...){
  .Deprecated("chull", package="ipeglim")
  chull(...)
}
NULL
