## ipeglim/inst/thesis/fig/xtms0.R
## Chel Hee Lee <gnustats@gmail.com>
## Modified on 2013.NOV.07
##
## Searching extreme points 

rm(list=ls())

lc0 <- list(lhs=rbind(c(-1,-2), c(1,-2), c(1,0), c(0,1)), rhs=c(-10,0,2.5, 0.5))
xtms <- iprior(eqns=lc0, verbose=FALSE)
xtms

# par(mfrow=c(1,1), mar=c(2,3,2,1)+0.1)
plot(xtms, xlim=c(0,10), ylim=c(0,5), 
     xlab=expression(alpha), ylab=expression(beta))
abline(v=2.5, h=0.5, lty="dashed")
abline(a=5, b=-0.5, lty="dashed")
abline(a=0, b=0.5, lty="dashed")
