## ipeglim/inst/thesis/fig/xtm0_2.R
## Chel Hee Lee <gnustats@gmail.com>
## Modified on 2013.NOV.07
##
## Searching extreme points 

rm(list=ls())

par(mfrow=c(1,2), mar=c(2,3,2,1)+0.1)

lc0 <- list(lhs=rbind(diag(2), -diag(2)), rhs=rep(-1,4))
xtms <- iprior(eqns=lc0, verbose=FALSE)
xtms

plot(xtms, xlim=c(-1.5,1.5), ylim=c(-1.5,1.5), 
     xlab=expression(alpha),
     ylab=expression(beta))
abline(v=c(-1.0, 1.0), h=c(-1.0, 1.0), lty="dashed")

lc0 <- list(x=0, y=0, r=1, len=15)
xtms <- iprior(circle=lc0)
xtms

plot(xtms, xlim=c(-1.5,1.5), ylim=c(-1.5,1.5),
     xlab=expression(alpha),
     ylab=expression(beta))
abline(v=0, h=0, lty="dashed")
