\name{print.imprecise}
\alias{print}
\alias{print.imprecise}
\alias{print.summary.imprecise}
\title{Printing Imprecise Class Objects}
\usage{
  \method{print}{imprecise} (x, ...)

  \method{print}{summary.imprecise} (x, ...)
}
\arguments{
  \item{x}{the object of classes \code{imprecise} or
  \code{summary.imprecise}.}

  \item{...}{further arugments to be passed to
  \code{print}.}
}
\description{
  The function \code{print.imprecise} is the
  \code{imprecise} method of the generic function
  \code{print} which displays summaries produced from two
  classes of \code{imprecise} for an imprecise prior and
  \code{summary.imprecise} for an imprecise posterior.
}
\author{
  Chel Hee Lee <\email{gnustats@gmail.com}>
}
\references{
  Lee (2013) ``Imprecise inferential framework'', PhD
  thesis.
}

