\name{set.grid.imprecise}
\alias{set.grid.imprecise}
\title{Generates Grid-Points in X-Y Coordinate System}
\usage{
  set.grid.imprecise(obj, len = 5, ...)
}
\arguments{
  \item{obj}{An object of class \code{imprecise}}

  \item{len}{A scalar value that implies a length}

  \item{...}{other arguments to be passed to the function
  \code{set.grid}.}
}
\description{
  The function \code{set.grid} generates grid-points in the
  box-constrained region (in 2D) using maximum and minimum
  of \code{xtms}.
}
\note{
  The function \code{set.grid} is recommended to use on the
  box-constrained type in two dimensional problem rather
  than three or more. In general, it is used for a surface
  of the constrained convex polygon.

  For the safe study, \code{set.grid} stops if
  \code{m0shape=sphere3d}.
}
\author{
  Chel Hee Lee <\email{gnustats@gmail.com}>
}
\seealso{
  \code{\link{expand.grid}}
}

